#include <cstdio>

int ans, n;
char T[1 << 16], P[1 << 15];
int L[1 << 15];

// functie de citire
void read()
{
	freopen("circular.in", "r", stdin);
	scanf("%d", &n);
	scanf("%s %s", T + 1, P + 1);
}

// functie prefix
void prefix(char P[], int L[])
{
	L[1] = 0;
	for (int p = 2; p <= n; ++p)
	{
		int k = L[p - 1];
		while (k > 0 && P[k + 1] != P[p])
			k = L[k];
		if (P[k + 1] == P[p])
			++k;
		L[p] = k;
	}
}

// functie kmp
int kmp(char T[], char P[], int L[])
{
	int k = 0;
	for (int t = 1; t <= n + n; ++t)
	{
		while (k > 0 && P[k + 1] != T[t])
			k = L[k];
		if (P[k + 1] == T[t])
			++k;
		if (k == n)
			return t - k;
	}
	return -1;
}

void solve()
{
	for (int i = 1; i <= n; ++i)
		T[i + n] = T[i];

	prefix(P, L);
	ans = kmp(T, P, L);
}

void write()
{
	freopen("circular.out", "w", stdout);
	printf("%d\n", ans);
}


int main()
{
	read();
	solve();
	write();
	return 0;
}
