#include <cstdio>

int n, m, ans;
int plain[1 << 17], crypt[1 << 18], L[1 << 17], P[1 << 14], Iplain[1 << 17], Icrypt[1 << 18];

// functie citire
void read()
{
	int i;

	// intrare
	freopen("cifru1.in", "r", stdin);

	// citesc n, m
	scanf("%d%d", &n, &m);

	// citesc plaintextul
	for (i = 1; i <= n; scanf("%d", &plain[i++]));

	// citesc criptotextul
	for (i = 1; i <= n; scanf("%d", &crypt[i++]));
}

// functie prefix pentru P cu rezultat in L
void prefix(int P[], int n, int L[])
{
	int i, k;

	// L1
	L[1] = 0;

	// prefix
	for (i = 2; i <= n; ++i)
	{
		// k initial
		k = L[i - 1];

		// potrivesc
		while (k > 0 && P[i] != P[k + 1])
			k = L[k];

		// maresc
		if (P[i] == P[k + 1])
			++k;

		// k final
		L[i] = k;
	}
}

// functie kmp pentru T, P, L cu rezultat d = deplasament minim
int kmp(int T[], int n, int P[], int m, int L[])
{
	int k = 0, i;

	// prefix
	prefix(P, m, L);

	// kmp
	for (i = 1; i <= n; ++i)
	{
		// potrivesc
		while (k > 0 && T[i] != P[k + 1])
			k = L[k];

		// maresc
		if (T[i] == P[k + 1])
			++k;

		// compar
		if (k == m)
			return i - k;
	}

	return -1;
}

// functie calcul forma independenta de valori a lui str in res
void dif(int str[], int n, int res[])
{
	int i;
	int ult[1 << 17];

	// initializez
	for (i = 1; i <= n; ult[i++] = 0);

	// setez forma independenta de valori (prima parcurgere)
	for (i = 1; i <= n; ++i)
	{
		if (ult[str[i]] > 0)
			res[i] = i - ult[str[i]];

		ult[str[i]] = i;
	}

	// setez forma independenta de valori (prima parcurgere)
	for (i = 1; i <= n; ++i)
		if (res[i] == 0)
			res[i] = n - ult[str[i]] + i;
}

// functie rezolvare
void solve()
{
	int i, d;

	// calculez forma independenta de valori a plaintextului
	dif(plain, n, Iplain);
	
	// calculez forma independenta de valori a plaintextului
	dif(crypt, n, Icrypt);

	// dublez forma independenta de valori a criptotextului
	for (i = 1; i <= n; ++i)
		Icrypt[i + n] = Icrypt[i];

	// calculez functia KMP pe cele doua forme pentru a obtine d
	ans = kmp(Icrypt, n + n, Iplain, n, L);

	// reconstitui permutarea de la d incolo
	for (i = 1; i <= n; ++i)
		P[plain[i + n * (i <= ans) - ans]] = crypt[i];
}

// functie scriere
void write()
{
	int i;

	// deschid
	freopen("cifru1.out", "w", stdout);
	
	// scriu d
	printf("%d\n", ans);
	
	// scriu permutarea
	for (i = 1; i < m; printf("%d ", P[i++]));
	printf("%d\n", P[m]);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
